
//  Copyright © 2015年 jacob. All rights reserved.
//

#include "meun.h"
#define N 100//定义联系人的数量

//定义结构体
typedef struct  {
    char name[10];
    char number[12];//11位的手机号码
}penson;

//用于存储所有联系人的数组
penson contacts[N];//存储10个

//定义用于记录联系人的个数
int count=0;
//定义数据文件存放
char *filePath="telbook.data";

//通讯录的菜单界面设置
void caiDan(){
    //定义变量
    int num=0;
    printf("**********************\n");
    printf("*** 欢迎使用通讯录   ***\n");
    printf("***  1.添加联系人    ***\n");
    printf("***  2.删除联系人    ***\n");
    printf("***  3.修改联系人    ***\n");
    printf("***  4.查看所有联系人 ***\n");
    printf("***  5.搜索联系人    ***\n");
    printf("***  6.退出系统      ***\n");
    printf("**********************\n");
    printf("请输入您的选择:");
    //获取用户的输入
    scanf("%d",&num);
    
    //根据用户的输入进入相应的功能模块
    switch (num) {
        case 1:
            add();
            break;
        case 2:
            deletePerson();
            break;
        case 3:
            revisePerson();
            break;
        case 4:
            checkAllPerson();
            break;
        case 5:
            search();
            break;
        case 6:
            leave();
            break;
            
        default:
            printf("请输入正确的编号\n");
            break;
    }
    
    
}
//初始化文件
void init(){
    FILE *fp=fopen(filePath, "r");
    if (fp!=NULL) {
        //读取个联系人的个数
        fread(&count, sizeof(count), 1, fp);
        //读取联系人个数到数组
        for(int i=0;i<count;i++){
            fread(&contacts[i], sizeof(penson), 1, fp);
        }
        
    }
    else{
        fp=fopen(filePath, "wb");
        fwrite(&count, sizeof(count), 1, fp);
        printf("新建文件成功\n");
    }
    fclose(fp);
}

//添加联系人
void add(){
    int num;
    //输出提示信息,count=0;
    printf("请输入您要添加的姓名:");
    scanf("%s",contacts[count].name);
    printf("请输入您要添加的电话:");
    scanf("%s",contacts[count].number);
    printf("请确认信息:1.确认 2.取消并返回 3.退出系统\n");
    scanf("%d",&num);
    if(num==1){
        //添加一个联系人自增一次
        count++;
        //写入文件中
        writeFile();
        printf("1.继续添加  2.返回菜单 3.退出系统\n");
        int num1;
        scanf("%d",&num1);
       if(num1==1)
       { add();
       }
        else if(num1==2){
            caiDan();
        }
        else {
            leave();
        }

    }
    else if(num==2){
        caiDan();
    }
    else {
        leave();
    }
    
}
/**
 *  删除联系人信息
    1.根据编号删除,确认标号是否在范围内
    2.输出编号对应的姓名和电话
    3.提示用户是否删除
 */
void deletePerson(){
    int num;
    //输出提示信息
    printf("请输入您要删除的1-%d编号:\n",count);
    int num2;
    scanf("%d",&num2);
    //根据编号匹配输出信息
    if(num2<=count&&num2>0)
    {   //contacts[]是从0开始存储的,因此编号要减1
        printf("编号\t  姓名\t  电话\t \n");
        printf("%d\t  %s\t  %s\t \n",num2,contacts[num2-1].name,
               contacts[num2-1].number);
        printf("1.确认删除  2.返回菜单  3.退出\n");
        scanf("%d",&num);
        if(num==1){
            //当删除的是最后一个人,直接减一
            if(num2==count)
            { count--;
                writeFile();
                choose();
            }
            else{
            //删除该编码的信息,利用后面的信息替代当前的
            for(int i=num2;i<=count;i++)
            { contacts[i-1]=contacts[i];
            }
                count--;
                //写入文件
                writeFile();
              //提示用户是否继续操作
                choose();
            }
        }
        else if(num==2){
            caiDan();
        }
        else {
            leave();
        }
        
    }
    else {
    printf("请输入范围内的编号\n");
        choose();
    }
   }

/**
 *  修改联系人
  1.根据输入的姓名匹配
 2.输出姓名对应的电话,修改姓名or电话
 3.确认是否修改
 4.如果没有匹配的信息提示用户
 */
void  revisePerson(){
    //输出提示信息
    printf("请输入您要修改的1-%d编号:\n",count);
    int num2;
    scanf("%d",&num2);
    //根据编号匹配输出信息
    if(num2<=count&&num2>0)
    {
        printf("编号\t  姓名\t  电话\t \n");
        printf("%d\t  %s\t  %s\t \n",num2,contacts[num2-1].name,
               contacts[num2-1].number);
        printf("1.修改姓名 2.修改电话 3.返回菜单  4.退出\n");
        int num;
        scanf("%d",&num);
        if (num==1){
            printf("请输入修改后的姓名:");
            scanf("%s",contacts[num2-1].name);
            writeFile();
            choose();
        }
        else if(num==2){
            printf("请输入您修改后的电话:");
            scanf("%s",contacts[num2-1].number);
            writeFile();
            choose();
        }
        else if(num==3){
            caiDan();
        }
        else {
            leave();
        }
        
    }
    else {
        printf("请输入范围内的编号\n");
        choose();
        
    }

}
//查询所有联系人
void checkAllPerson(){
    //当count=0时,提醒用户是否需要添加信息
    if(count==0)
    {printf("还没有小伙伴~~~~(>_<)~~~~ \n");
        printf("1.添加  2.退出\n");
        int num1;
        scanf("%d",&num1);
        if(num1==1){
            add();
        }
        else {
            leave();
        }
    }
    else {
        //打印所有的联系人
        printf("******联系人列表******\n");
        printf("编号\t   姓名\t     电话\t \n");
        for (int i=0; i<count; i++) {
    printf("%d\t   %s\t  %s\t \n",i+1,contacts[i].name,contacts[i].number);
        }//提示用户进行其他操作
        choose();
    }
    }
/**
 *  搜索联系人
   1.获取姓名,匹配
   2.匹配失败提示用户
   3.匹配正确,打印出该联系人的全部信息
 */
void  search(){
    //输出提示信息
    printf("请输入您要搜索的姓名:");
    char name[10];
    scanf("%s",name);
    //遍历contacts里面存储的信息进行匹配
    int b=0;
    for(int i=1;i<=count;i++){
     b=strcmp(contacts[i-1].name,name);
       
   if (b==0) {
        printf("信息如下:\n");
        printf("%d\t  %s\t  %s\t \n",i,contacts[i-1].name,contacts[i-1].number);
       break;
            }
    }
    if (b!=0){
        printf("通讯录里没有该小伙伴(⊙o⊙)哦\n");
    }
    
     choose();
   }
/**
 *  6.退出系统
 */
int leave(){
    printf("系统正在退出中......\n");
    printf("成功退出\n");
    return 0;
}
//把数据写入文件中
void writeFile(){
    //打开文件
    FILE *fp=fopen(filePath,"wb");
    if(fp!=NULL){
    //写入联系人个数
    fwrite(&count, sizeof(count), 1, fp);
    //写入信息
        for(int i=0;i<count;i++){
            fwrite(&contacts[i], sizeof(penson), 1, fp);
        } }
    //关闭文件
    fclose(fp);
    printf("成功保存到文件中\n");
        
}
//提示用户是否继续操作
void choose(){
    printf("1.返回菜单  2.退出\n");
    int num;
    scanf("%d",&num);
    if(num==1){
        caiDan();
    }
    else leave();

}